#include <SoftwareSerial.h>

#define output(directions,pin) (directions |= pin) // set port direction for output
#define set(port,pin) (port |= pin) // set port pin
#define clear(port,pin) (port &= (~pin)) // clear port pin

#define led_delay() _delay_ms(100) // LED flash delay
#define led_delay_receive() _delay_ms(800) // LED flash delay

#define led_port PORTB
#define led_direction DDRB
#define led_pin (1 << PB0)


#define node_id '1'

#define serial_pin_in 2
#define serial_pin_out 3

SoftwareSerial mySerial(serial_pin_in,serial_pin_out);

void flash() {
   //
   // LED flash delay
   //
   clear(led_port, led_pin);
   led_delay();
   set(led_port, led_pin);
   }

int message;

void setup() {
   //
   // set clock divider to /1
   //
   CLKPR = (1 << CLKPCE);
   CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);
   //
   // initialize output pins
   //
   set(led_port, led_pin);
   output(led_direction, led_pin);

   // initialize serial pins
   //
   pinMode(serial_pin_out,INPUT); //close Rx port by setting it as an input.
   pinMode(serial_pin_in,INPUT);  //set Tx as an input.
   //
   // initialize serial
   //
   mySerial.begin(9600);
}

void loop() {
  flash();

  if (mySerial.available() > 0) {
    
    // read the incoming byte:
    message = mySerial.read();

    led_delay();
    
    if (message == node_id) {
       pinMode(serial_pin_out,OUTPUT);
       mySerial.write(" -> node: ");
       mySerial.write(message);
       led_delay_receive();
       pinMode(serial_pin_out,INPUT);
       }
    
    (PORTB &= (~(1 << PB0))); //Turn off the LED
  }
}
